--- Basically need to copypasta the whole file... :(

local fname = current_lua_file()

gui[fname] = function(_ENV)

depends(fname)

--local parent_env = _ENV

local _ENV = ensure_property_env(_ENV,'designer_pane')

designer_pane.environment_loop='SHIP_EDIT_ENVIROMENTAL'

--insert(_ENV,..parent_env)

local is_tracking_object, is_ship in _ENV
local set_frame_color4 ,gl_box, glBox, lMouseClick, esc_pressed in _ENV
local program_time,clipped_box in _ENV
local min,max,round in math
local transform = translate_rotate_fun
local format in string
local unpack in table

frames = DesignerSkin1.NewFrames(_ENV)

DesignerSkin0(_ENV)

link_history = rawget(_ENV,'link_history') or new_link_history()


zoom_overload=false


font_name="fonts/bitstream/verabd.TTF"

fr=2
local function calc_fr() 
  return screen_h<900 and 1 or 2
end

function set_hardpoint_dropdown_options()

  local extra_options = _SAFE
  
  if active_design and open_args.mode=='Refit'
    extra_options=get_design_refit_info(active_design,gui_player())
  end

  local extra_names = {}
  for i,info in ipairs | extra_options
    extra_names[i] = info.design.design_name
  end

  local dropdown_options = join(extra_names,|) {
    'Auto Design: Balanced',
    'Auto Design: Escort',
    'Auto Design: Siege',
    'Clear All',
  }

  insert(dropdown_options,

    left_justify=30,

    get_title = function()
      return 'Hardpoints'
    end,

    on_select = function(key,_,i)
      if i<= #extra_options
        local design in extra_options[i]!
        active_design.filled_mounts = copy(design.filled_mounts)
        active_design.active_mods = copy(design.active_mods)
        active_design.design_hint = design.design_hint
        active_design.design_name = design.design_name
        title_edit.set_text(design.design_name)

      elseif key == 'Clear All'
        designer_pane.clear_all_hardpoints()
      else
        local design_key = key:match 'Auto Design: (%S+)'
        designer_pane.do_autodesign(design_key!)
      end
    end,
  )

  --if 

  frames.hardpoint_frame.set_dropdown_options(dropdown_options)

end



function on_open(args)
  hide_obsolete_components=false
  hide_incompatible_componenets=true

  Music.set_theme 'design'

  open_args = args

  local mode in args

  if mode == 'Edit'
    set_active_design( Design.clone( args.source_design ) )
  elseif mode == 'New'
    set_active_design(args.design)
  elseif mode == 'Refit'
    set_active_design( args.design.clone() )
  else
    trace_error('unknown designer mode: ',mode)
  end

  insert(active_design,..args.design_key)

  name2sys=empire:available_part_info()!
  init_ordered_module_names()
  refresh_active_vars()

  set_hardpoint_dropdown_options()
end


function Property.drawer_table()
  return drawers[active_design?.ship_drawer]
end

function Property.empire()
  return gui_player()
end

function part_palette(part_drawer)
  if active_design

    if active_design.planet_info
      return drawers.get_empire_palette(empire, empire : prefered_theme() )
    else
      return drawers.ship_part_palette( active_design.ship_drawer, part_drawer, ship_palette )
    end

  end
end

Property.ship_palette =  function()
  if active_design
    return drawers.get_ship_palette(active_design.ship_drawer,empire)
  end
end


Property.palette =  function()
  trace_error('hi',2,4)
end


Property.ship_drawer = function()
  return active_design?.ship_drawer
end

function frame_color()
  set_frame_color4(.15,.15,.15,1)
end

function bk_color() 
  set_frame_color4(.3,.3,.3,1)
  --set_frame_color4(.0,.3,.6,1)
end

function ship_bk_color() 
  set_frame_color4(.5,.5,.5,1)
end

depends("Design")
depends("DesignDrawing")
depends("DesignTech")
depends("@DesignIO")
depends("new_skin")
depends("DesignerSkin0")
depends("@DesignerSkin1")

local standard_descs = copy( hardpoint_descs )

--for _,s in ipairs {
--    'Shields', 'Crew', 'Speed', 'Tanks', 'Armor', 'Munitions','Hull','Hazard','Cost'
--  }
--  standard_descs[s]=info_desc(s)
--end


function set_desc_text(key)
  

  --infobox.push_text(text)
  link_history.follow_link( key )
  --console(..key)
  frames.info_frame.clear_text()
end

function clear_all_hardpoints()
  for i, mount in active_design.mounts()
    if mount.mtype~='Built-In'
      active_design.filled_mounts[i]=nil
    end
  end
end

function do_autodesign(auto_design_key)
  local prefs_table = {
    Balanced = PartOrdering.generic_autodesign,
    Escort = PartOrdering.escort_autodesign,
    Siege = PartOrdering.siege_autodesign,
  }

  local prefs = prefs_table![auto_design_key]

  local design = PartOrdering.greedy(prefs) {
    --initial_design=active_design,
    empire=gui_player(),
    config_table=active_design!.config_table,
    config_name=active_design!.config_name,
    ..active_design.ship_drawer,

    ..active_design.planet_info,
  }

  active_design.active_mods = copy | design.active_mods


  for i, mount, name, mods in active_design.mounts()
    if mount.mtype~='Built-In'
      active_design.filled_mounts[i]=design.filled_mounts[i]
    end
  end
end

function get_key_info(key)


  if type(key)=='number'
      
    if active_design!.filled_mounts[key]
      return get_installed_weapon_desc(
        active_design.filled_mounts[key],
        active_design.mount_info(key),
        active_design.active_mods[key], 
        empire) 
    end 

    key = mount_desc_text | active_design!.mount_info(key)
  end

  if key==active_design?.hull_desc_key
    return add_desc_prefix( active_design.config_name, drawers.HullDescriptions[key] or format("MISSING DESCRIPTION FOR hull_desc_key=%q",tostring | key) )
  end

  --print(key,PartInfo[key],hardpoint_descs[key] )

  if PartInfo[key]
    return get_system_desc(key,empire)
  end

  if hardpoint_descs[key] 
    return hardpoint_descs[key]
  end



  return info_desc(key) 

  --return hardpoint_descs[key] or info_desc(key) or format("<missing info for %q>",tostring(key))
end

function on_close()
  link_history.clear()
   
end

local get_default_part_drawer,ship_drawer,drawer_t,mounts,draw_station_weapons,mount_info,num_mounts,mount_mod_conflicts,get_drawer_info,
    filled_mounts,prefered_hardpoint_type,get_prefered_drawer

function cache_active_vars()
  get_default_part_drawer,ship_drawer,drawer_t,mounts,draw_station_weapons,mount_info,num_mounts,mount_mod_conflicts,get_drawer_info,
    filled_mounts,prefered_hardpoint_type,get_prefered_drawer
    in ( active_vars or generator(nil) )
end

if(active_vars)
  cache_active_vars()
end


function set_active_design(design)
  active_design = design

  if(design)
    console('setting design name')
    set_design_name(active_design.design_name)

    link_history.clear()


    if active_design

      set_desc_text(active_design.hull_desc_key)

      local function mount_itr(_ENV,k)

        k=k+1

        if(k> num_mounts() )
          return
        end

        local spec= hover_k==k and dragging or filled_mounts[k]
        local mods = hover_k==k and source_mods or active_mods[k]

        return k,  mount_info(k),spec,mods
      end


      active_vars = setmetatable(
        {
          last_hardpoint_type = setmetatable({},{__newindex=function(t,k,v) print('set last hardpoint',k,v) rawset(t,k,v) end}),
          hull_specs={},
        }, 
        { __index = active_design } )

      active_vars.visible_mounts = catch(mount_itr, active_vars, 0)

    end


  else
    active_vars=nil
  end

  refresh_active_vars()

  collectgarbage()
end


function refresh_active_vars()

  reset_default_drawers()
  hardpoint_cache_active_vars()
  modules_cache_active_vars()
  cache_active_vars()

end


display_systems=false

function drawer_to_scale(k)

  return drawers[k].design_scale or 1 or error("missing design_scale for "..k,2)
end



HardpointList(_ENV)
AvailableSystems(_ENV)
--ChooseHull(_ENV)

local drawer_to_degree = {
--  HawkBB1=-45,
}

--=

source_mods={}

function part_clicked(el)

  local shift_down,ctrl_down,enable_dev_hooks,Sounds in _ENV


  local filled=active_vars.filled_mounts[el.part_i]

  if filled and enable_dev_hooks() and ctrl_down()
    print 'hi there'
    local file, line in PartInfo[filled]!.declared
    debug_file_and_line(file,line)
    return
  end

  if not name2sys[filled]
    return
  end

  local _ENV = active_vars

  -- if shift is not down we enable swapping and delete the
  -- source. 
  -- if shift is down, we just copy the source info into dragged,
  -- and leave the click hardpoint alone.
  if(not shift_down())

    source_k=el.part_i
    source_mods=shallow_copy(active_mods[source_k])
    source_spec=filled_mounts[el.part_i]

    console('setting source k',..source_k)

    dragging=filled
    el.dragging=filled
    filled_mounts[el.part_i]=false
    active_mods[source_k]={}
    Sounds.PICKUP_PART()
  else
    el.dragging=filled
    source_mods=shallow_copy(active_mods[el.part_i])
  end

  local hardpoint_type,part_drawer=get_drawer_info(filled,mount_info(el.part_i) )
  last_hardpoint_type[filled] = hardpoint_type
  if(hardpoint_type=="HawkTube")
    last_hardpoint_type.tube_hint= part_drawer=="Hawk_left_missile" and "left" or "right"
  end
end


-- used to make installed, then emptied hardpoints show
-- "ghosts" that match whatever was last installed
local old_default_drawer={}
local old_default_dtype={}


function reset_default_drawers()
  old_default_drawer={}
  old_default_dtype={}
end


is_system=set("System","Armor")


do

  local x,y,w,h,s0,i,mount,sysname
  local hover_k,dragging 
  local aggressive_alpha=false
  local hardpoint_type 
  local transform

  local request_mlocation = restore_color | function( mlocation)

      local filled = sysname
      local PartDrawerInfo in drawers
      local part_drawer

      -- figure out if we're drawing a ghost part (for an unfilled
      -- mount) or an actual installed part

      local allowed = dragging and name2sys[dragging] and mount_allowed_types[ mount.mtype] [name2sys[dragging].type ]

      if filled

        hardpoint_type,part_drawer = active_design.get_drawer_info(filled,mount)

        if(not active_vars.dragging or hover_k==i )
          set_frame_color4(1,1,1,1)
        else
          if(allowed)
            set_frame_color4(1,1,1,aggressive_alpha and .75 or 1)
          else
            invalid_part_color()
          end
        end


        old_default_drawer[i]=part_drawer
        old_default_dtype[i]=hardpoint_type

      elseif(not part_drawer)


        -- don't draw anything in the case of a bases linked mounts
        if(mount.mlocation_list and drawer_t.expected_s>6)
          return
        end

        local alpha = aggressive_alpha and .25 or .5

        set_frame_color4(1,1,1,alpha)

        part_drawer = old_default_drawer[i]

        if(part_drawer)
          hardpoint_type=old_default_dtype[i]
        else
          hardpoint_type,part_drawer=get_default_part_drawer(i)     
        end


        if(active_vars.dragging)
          if(not allowed)
            if(aggressive_alpha)
              set_frame_color4(.3,.3,.3,.3)   
            else
              invalid_part_color()
            end
          end

        end
      end

      local _TRACE_INFO = arg_list(..part_drawer,..ship_drawer,..hardpoint_type)

      local drawer_table = drawers[ship_drawer]

      if not part_drawer
        goto next_part
      end

      
      local gunport =  is_gunport(ship_drawer,hardpoint_type,mlocation)
      local gunshift = 0


      if( gunport )
        --print(..setting, filled and 1 or 0,..mlocation )
        set_gunport_target( filled and 1 or 0 ,transform, hardpoint_type, mlocation)
      end

      -- kludge to avoid the case where orthin try to show unfilled
      -- artillery mounts.
      if (not filled) and (hardpoint_type=='Siege')
        goto next_part
      end


      if (ship_drawer=='MantaTD') and (filled=='Primary Artillery')
        --print('hrm..')
        drawer_table.components.supergun_one.full_draw(transform, empire_ship_stub(gui_player()), ship_palette)
      end

--      print(..filled,..hardpoint_type)

      if is_component_hardpoint(hardpoint_type)
        if filled
          drawer_table!.request_designer_component(transform, empire_ship_stub(gui_player()), ship_palette, hardpoint_type, part_drawer)
        else
          drawer_table!.request_designer_component(transform, empire_ship_stub(gui_player()), ship_palette, hardpoint_type, part_drawer)
        end
        --goto next_part
      else
        drawers.request_drawer_part(transform,
          ship_drawer,
          drawers.ship_part_palette(ship_drawer,part_drawer,ship_palette),
          hardpoint_type,part_drawer,mlocation, nil)

      end



       if mlocation

         local hardpoint_type,part_drawer=get_default_part_drawer(i)  

         local weapon_table = drawer_table![hardpoint_type]

         local offx,offy= weapon_table.anchor[mlocation]()
         local px, py, pw, ph = ui_transform_to_square(transform)

        -- print(..offx,..offy)

          local rx=px+offx*pw
          local ry=py+offy*ph
          local rw=drawer_table.normal_scale*90*pw
          local rh=drawer_table.normal_scale*90*pw

          rx,ry-=.5*rw

          --print(rx,ry,rw,rh)

--          request_component_function(transform,function()
          --glBox(rx,ry,rw,rh)
--          end,2)

          local el = element(rx,ry,rw,rh)

          if(filled)
            el.on_click=part_clicked
            el.part_i=i
            el.on_hover=hand_cursor
          else
            el.desc_text = mount.mtype

            -- "<missing hardpoint description>" 
          end

       end

      ::next_part::

  end


  local design_ship_stub = weak_memoizeNN | function()

    return newproxy | function(k)
     --print(..k,..v)
     local r= active_design[k] or active_vars.hull_specs?[k]
     return r
    end

    

  end

  local function base_hull_request()

    --glBox | frames.profile_rect()
    local x,y,w,h = frames.profile_rect()

    local ship_stub=empire_ship_stub( empire ) 
    local x,y,s,degree = drawer_table.rect_fit(ship_stub, x,y,w,h)

    local el = element( frames.profile_frame.rect() )

    el.desc_text=active_design.hull_desc_key
    el.on_click=profile_clicked

    local expected_s, expected_rect_h in active_design.drawer_t

    local transform = new_request_transform(x,y,s,degree)

    local drawer_table = drawers[ ship_drawer ]
    local empire = gui_player()



    drawer_table.request_ship_draws(transform, design_ship_stub() )
--    drawer_table.module_engine_requests?(transform,active_design.modules)


    return transform

  end

  function request_profile()

  
    transform = base_hull_request()


    --x,y,w,h=frames.profile_rect()

    local x,y,s,degree = drawer_table.rect_fit(empire_ship_stub( empire ) , frames.profile_rect())


    hover_k,dragging in active_vars

    for i_,mount_,sysname_ in active_vars.visible_mounts() do
      i, mount, sysname = i_,  mount_,  sysname_

      hardpoint_type in mount

      if(hardpoint_type == "MaskedBeamMounts" or not hardpoint_type ) goto continue end

      if(not display_systems and is_system[hardpoint_type]) goto continue  end

      if(mount.mlocation) 
        request_mlocation(mount.mlocation) 
      elseif(mount.mlocation_list)
        for k,v in ipairs(mount.mlocation_list) do
          request_mlocation(v) 
        end

      end


      ::continue::
    end
  
  end

end

function invalid_part_color()
--  set_frame_color4(1,.3,0,.6)
  set_frame_color4(.5,.5,.5,.5)
end


local commit_fun = {}


function commit_fun.New()

  local design = active_design




  if active_design.carrying_design
    local new_design = new_design_ref(design)
    local new_carrying_design = new_design_ref(active_design.carrying_design)
    new_carrying_design.carried_design=new_design
    new_design.carrying_design=new_carrying_design
    new_carrying_design.design_name = design.design_name .. ' Transport'
    empire.designs[new_carrying_design._ikey] = new_carrying_design
  else
    local new_design = new_design_ref(design)
    empire.designs[new_design._ikey] = new_design
  end



end

-- so, at the moment, the "all_designs" array expects to be
-- dense -- and there's no way of deleting designs.  this makes
-- handling the edit case a bit delicate.
function commit_fun.Edit()
  
  local designs in empire!
  local old_key = open_args!.design_key
  

  local old_design = Design.clone | all_designs[old_key]
  local carrying_design in active_design

  local new_old_design_key

  -- update planet production orders to avoid referencing a
  -- non-existent design
  if carrying_design
    for planet ; empire.planets
      if planet.fixed_production and planet.building_design == carrying_design._ikey
        if not new_old_design_key
          local new_old_design = new_design_ref( Design.clone | carrying_design)
          local new_old_carried = new_design_ref(old_design)
          new_old_design.carried_design = new_old_carried
          new_old_design_key = new_old_design!._ikey 
        end

        planet.building_design = new_old_design_key
      end
    end
  else
    for planet ; empire.planets
      if planet.fixed_production and planet.building_design == old_key
      
        -- create a new version of the old design, and assosiate it with the
        -- planet's production.  enter that design into the all_design
        -- table, but, not into the empire's recorded table.  this makes it
        -- more or less "invisible"
        if not new_old_design_key
          local new_old_design = new_design_ref(old_design)
          new_old_design_key = new_old_design!._ikey 
        end

        planet.building_design = new_old_design_key
      end
    end
  end

  all_designs[old_key] = active_design

  if carrying_design
    carrying_design.design_name = active_design.design_name .. ' Transport'
  end

end

function commit_fun.Refit()
  local on_commit in open_args!
  on_commit(active_design)

  --[[

    -- implicitly overwrite the empire's design for this ship type
    local designs in empire
    local new_name = active_design.design_name
    if not designs[new_name]
      designs[new_name]=new_design_ref(active_design)
    elseif not table_eq(designs[new_name],active_design)
      all_designs[ designs[new_name]._ikey ] = active_design
    end

  --]]

end

local function save_and_close(el)
  active_design.design_name=title_edit.get_text()

  local mode in open_args!

  execute_order( mode..' '.. active_design.design_name , commit_fun![mode] )

  close_fullscreen_pane()
end

local draw_missing_depo_warning = restore_color | function()
  local profile_frame in frames
  local x,y = profile_frame.power_warning_center()
  set_frame_color4(1,.3,0,1)
  centered_text(Skin0.font,26,x-80,y+12,('outpost designs must\ninclude a fuel depot') : upper() )
end

local draw_power_warning = restore_color | function()
  local profile_frame in frames
  local x,y = profile_frame.power_warning_center()
  set_frame_color4(1,.3,0,1)
  centered_text(Skin0.font,26,x,y+12,('insufficient\npower') : upper() )
end

local draw_profile = safe_requests | function()

  if(active_design)

    --local transform = request_hull_draw(ship_drawer,
    --  , palette )

    local profile_frame in frames

    if active_design.planet_info
      local x,y,w,h=profile_frame!.bk_rect()
      local s=max(w,h)
      clipped_box(x,y,w,h,ImprovementDrawers["Planetary Defenses"],0,0,s)
    else
      profile_frame.draw_bk()
      call_with_gl_white(request_profile)
      execute_draw_requests()
    end



    profile_frame.draw()

    local grey

    if active_design.invalid
      if active_design.invalid=='outpost_missing_depot'
        draw_missing_depo_warning()
      else
        draw_power_warning()
      end
      grey=true
    end

    do

      if open_args?.mode=='Refit'
        grey = open_args.design.refit_cost(active_design) == 0
      end


      insert( profile_frame.check_button(grey),
        on_hover = grey and grey_cursor or hand_cursor,
        on_click = (not grey) and save_and_close, 
        desc_text = grey and (open_args.mode=='Refit') and 'Ship Refits'
      )

    end

    --print(active_design.invalid)


    --set_frame_color4(1,0,1,1)
    --sprint(profile.close_box())
    --glBox(profile.close_box())

    --local el = element(profile.close_box())
    --el.on_hover = grey_cursor
    --el.on_click = close_pane
  end

end





local function draw_ship_title() 

  set_frame_color4(1,1,1,1)
  
  if active_design.can_edit_name
    title_edit.draw()
  else
    title_edit.draw('no_element')
  end


end


local function i2str(i)
  return format("%d",i)
end



local draw_stats do
  
  add_resize_callback | function()  

    local inset in frames.stats_frame!

    local x,y,w,h = inset()



    local min_em_height = 4.5
    local min_em_width = 26
    local max_em = 24
    local em = floor | min( h/min_em_height, w/min_em_width, max_em )

    --print(..em, h/min_em_height, w/min_em_width)

    local min_pt = 10
    pt = max(min_pt, em)

    local stats_cache = make_hover_text_cache {
      name = 'designer_stats',
      text_width = w,
      default_font_key=format('vera%d',pt),
      --bk_color = catch(0,0,0,.75),  
    }

    local function render(...)
      return stats_cache.lazy_gen | shorthand_format | format(...)
    end 

    local x0 = x+pt*.8
    local x1 = x+.5*w-pt*4.3
    local x2 = x+w-pt*8.4

    local y0 = y+h-pt*1.5
    local y2 = y+pt*.5
    local y1 = .5*(y0+y2)

    local stat_color = {
      shields = '1a94ff',
      armor = 'ffa20d',
      --hull = 'ff520e',
      crew = '5cd400',
      munitions='ff4603',

      neg_power = 'ff0000',
      --power='5cd400',
      --speed = 'ffffff',

    } 



    local stats in skin

    local itemstring(v)
      if type(v) == 'string'
        return v
      end
      if (v or 0) >= max_double
        return 'Inf '
      end
      return tostring(v)
    end

    local function stat_box(v,x,y,stat,icon,name,align)


      name = name or tostring(capitalize(stat))
      local item
      local color = stat_color[stat]
      if color
        item = color_desc_text(color, itemstring( v ) ) 
      else
        item = itemstring(v)
      end

      item ..= icon or format('<%s>', stat:upper() )

      local text = name.. ': ' .. (align or '')  .. item
      local word = render | text


      local el = element | box_grow(2,2,word.draw_bl(x,y))

      el.desc_text=name

    end

    local align1 = add_align(3.6)

    draw_stats = restore_color | function()
      set_frame_color4(1,1,1,1)
     
      frames.stats_frame.draw_bk()

      local specs = active_vars.hull_specs
      active_vars.update_hull_specs(specs)
      
      --set_frame_color4(0,0,0,.3)
      --glBox | inset()

      local word
      
      set_frame_color4(1,1,1,1)

      stat_box(specs.hull, x0,y0,'hull')
      stat_box(specs.armor, x1,y0,'armor',nil,nil,align1)

      local shield_regen = calc_shield_regen(specs.shields)
      local shield_str = string.format("%s/%s", itemstring(specs.shields), math.floor(itemstring(shield_regen)))
      stat_box(shield_str, x2,y0,'shields','<SHIELD>')

      local speed = empire : speed_from_class(specs.speed_class)
      stat_box(speed, x0,y1,'speed','<SPEED>')
      stat_box(specs.crew, x1,y1,'crew','<MARINES>',nil,align1)
      stat_box(specs.munitions, x2,y1,'munitions','<AMMO>')

      local metal_cost, hammer_cost,power in specs
      local cost_desc

      if open_args.mode=='Refit'
        cost_desc = 'Ship Refits'
        hammer_cost,metal_cost = open_args.design.refit_cost(active_design)
      end

      stat_box(hammer_cost, x0,y2,'Cost','<WRENCH>')
      stat_box(metal_cost, x1,y2,'Metal','<METAL>',nil,align1)
      stat_box(power, x2,y2, power < 0 and 'neg_power' or 'power', 
        power<0 and '<POWER_WARNING>' or '<DESIGN_POWER>',
        'Power')
      
      
      frames.stats_frame.draw_frame()
    end




  end

end

local function stats_el(x0,x1,y0,fh)
  return element(x0-2,y0-2,x1-x0+2,fh+6)
end



function centered_text_el(font_name,font_h,x,y,text,boarder)
  local _,_,w = centered_text(font_name,font_h,x,y,text)

  boarder=boarder or .3

  local extra = font_h*boarder

  --set_frame_color4(1,0,1,.5)
  return element(x-w*.5-extra,y-font_h*.5-extra,w+2*extra,font_h+2*extra,2)

end



local round in math
local function roundrect(x,y,w,h)
  
  if(not x) error("nil x sent to roundrect",2) end
  if(not y) error("nil y sent to roundrect",2) end
  if(not w) error("nil w sent to roundrect",2) end
  if(not h) error("nil h sent to roundrect",2) end

  return round(x),round(y),round(w),round(h)
end

--local double_lists=true

-- layout our own sub objects



function filled_from_temp(system_spec,i)
  local mount = mount_info(i)

  local system=shallow_copy(system_spec)

  --console('filled_from_temp',..system_spec)

  if(mount.n and WEAPONS[system.name] )
    system.n=mount.n
    system.base_power=system.power
    if(not system.active_mods)
      system.active_mods={}
    end
  end

  system.space=mount.space
  if(not system.space) 
    system.space=mount.n*6
  end


  return system
end


local function remove_conflicting_mods()

  local _ENV=active_design

  for i=1,num_mounts()

    -- i've got no idea why this table is occasionally hitting
    -- an uninitialized variable.
    -- hopefully it will go away once i clean up the hull switching
    -- logic
    if(not active_mods[i]) 
      --error(format("no mod initialized for mount %d",i))
      active_mods[i]={} 
    end

    local t=active_mods[i]


    local conflicts = mount_mod_conflicts[mount_info(i).mtype]

    if(not conflicts) goto next end

    for k,v in pairs(t) do
    
      if(conflicts[k] and t[k])
        --sprint("removing conflict with ", mount_info(i).mtype, k) 
        t[k]=nil 
      end

    end

    ::next::

  end
end


local function commit_mounts()
  --local design=active_design
  local Sounds in _ENV
  local _ENV=active_vars

  if(not hover_k and last_placed_time and global_time()-.5<last_placed_time and source_k~=last_placed_k)
    hover_k=last_placed_k
  end


  for i,mount,spec,mods in visible_mounts() do
    if spec and (filled_mounts[i]~=spec)
      Sounds.INSTALL_PART()
      print(..spec)
    end

    filled_mounts[i]=spec

    if not spec
      active_mods[i]={}
    else
      active_mods[i]=shallow_copy(mods or {})
    end
    
    --console(i,..spec,..t2s(active_mods[i]))

  end

  --design.filled_mounts=_filled
  --design.active_mods=_mods
end


local raw_draw = function()
  active_design.ensure_config_sanity()

  set_frame_color4(1,1,1,1)

  call_in_hint_context(fname,draw_profile)
  draw_ship_title() 
  draw_modules()
  draw_available()
  draw_stats()
  
--  draw_io()


  --save_drawfun( 'design_info',)
  frames.info_frame.draw()
end

draw = restore_color | FLAG_fun('dont_rotate_ship_profiles',|) function ()

  SCOPE_call(empire=gui_player(),raw_draw)
  

  --glBox | frames.info_frame.rect()

  --infobox.draw(skin.desc)


end


--!! Refresh
refresh = function (i,...)
  blue_cursor()

  limit_available=nil

  if(scrolling)
    scrolling()
    update_hover_alphas()
    return 
  end

  if(not scrolling)

    if(active_design)
      if(lMousePop())
        local pane = _ENV
        local _ENV = active_vars
        commit_mounts()
        remove_conflicting_mods()

        pane.source_mods={}
        hover_k=nil
        source_k=nil
        dragging=false

        --update_hull_specs()
      end
    end

    local lclick = nelement_refresh(i,...)
    local picked = get_callback_element(i)

    if(active_design)

      local link_history,hand_cursor,draw_at_cursor,lmouse_down,empire,active_design in _ENV

      local _ENV=active_vars
      if(lclick)
        dragging = picked.dragging

        -- specialized logic used by the designer screen
        if( dragging and last_hardpoint_type and not source_k )
          local part_drawer,hardpoint_type = active_design.get_prefered_part_drawer_from_name(dragging)

          print('getting prefer type for dragging', ..dragging, ..part_drawer,..hardpoint_type )
          last_hardpoint_type[dragging] = hardpoint_type
          
          --drawers.PartDrawer.hardpoint ( part_drawer )!

          source_mods={}
        end

        local mod=picked.mod
        if(mod)
      
          local k=picked.mount_i

          local system=filled_mounts[k]
          local activation=active_mods[k][mod]==nil or nil

          active_mods[k][mod]=activation
      
          link_history.follow_link(k)

        end
      end



      if(picked and (picked.dragging or picked.mod ) )
        hand_cursor()
      end

      if(lmouse_down())
        if(dragging)
          draw_at_cursor(dragging,picked)
        end

      else 
        dragging=false
      end

  
      update_hull_specs(hull_specs) 
    end

  end

  --if(ctrl_down())
  --  if(char_pressed("S")) on_save() end
  --end


  if(esc_pressed() ) 
    if fullscreen_pane then
      (fullscreen_pane.esc_handler or close_fullscreen_pane ) ()
    end
  end

end


function order.edit_designs()
  local empire = gui_player()


  if(editting_planet)

    local t = active_design.save_table()

    -- any changes we've made will overwrite both the planets
    -- current defense plan (if any), and the empires global
    -- defense plan

    t.ship_drawer=nil

    empire.defense_design_table = t

  else


    -- if we've deleted any designs that are currently being
    -- produced, switch those planets to autobuilding
    for planet in pairs(empire.planets) do

      local building_design in planet

      if( empire.designs[building_design] and not saved_designs[building_design] )
        order.set_autobuild(planet)
      end

      local to_delete = {}
      for i,info in ipairs | planet.production_queue
        local building_design in info
        if empire.designs[building_design] and not saved_designs[building_design]
          to_delete[i]=true
        end
      end

      print(..t2s | to_delete)

      for i in rpairs(to_delete,|) function(a,b) return a>b end
        order.remove_production_queue(planet,i)
      end

    end

    empire.designs=Design.saved_designs

  end


end


function checkin_design_changes()
  
  local old = copy(  gui_player().designs )

  if(editting_planet)

    local old = planet_defense_spec(editting_planet)
    local current = active_design.save_table()

    if(not table_eq(old,current))
      order.edit_designs()
    end
    
    editting_planet=nil

  elseif(not table_eq(old,saved_designs) )
    order.edit_designs()
  end

end




function title_font_h(ty)
  local font_h= round(.45*(h-ty))
  if(font_h<=2)
    font_h=2
  end
  return .5*(ty+y+h)-.2*font_h,font_h
end

function title_rect(dims,title)

  local px,py,pw,ph=dims()

  local ty,font_h = title_font_h(ph+py)

  centered_text(font_name,font_h,px+pw*.5,ty,title)
end


function get_design_name()
  local rval = title_edit.get_text()

  rval = rval:gsub("^%s*",'')
  rval = rval:gsub("%s*$",'')

  --printf("%q",rval)

  return rval
end

function set_design_name(name)
  printf('setting %q',name)
  if(not name) error("can't have a null design name",2) end
  title_edit.set_text(name)
end


--DesignLoadSave(_ENV)

if all_empires
  resize_callback()
end



if all_empires

  if active_vars

    console(..t2s | active_vars)

    for k, v in pairs(active_design)
      console(..k,..v)
    end
  end

end


end


--local function test()
--  local foo=2
  --local bar=6
  --return ..test,..foo,..bar
--  return
--end


--local a,b,c = get_vars ( fun() )

--print(..test())